-- File: mcursor.e
-- Author: Victor Milankovic

include mouse.e
include machine.e

-- Mouse cursor

sequence Cursors

Cursors=    --Initialize the mouse cursor variables
    {{
        #FF,#FF,#FF,#F3,#FF,#E1,#FF,#E1,#FF,#E1,#FF,#E1,#07,#E0,#00,#E0,
        #00,#80,#00,#00,#00,#00,#00,#00,#00,#00,#00,#00,#01,#80,#03,#C0,
        #00,#00,#00,#0C,#00,#12,#00,#12,#00,#12,#B0,#13,#4E,#12,#49,#12,
        #49,#72,#49,#92,#01,#90,#01,#80,#01,#80,#01,#80,#02,#40,#FC,#3F}, 
        5, 0,
    {
        #FF,#3F,#FF,#1F,#FF,#0F,#FF,#07,#FF,#03,#FF,#01,#FF,#00,#7F,#00,
        #3F,#00,#1F,#00,#0F,#00,#07,#00,#47,#18,#7F,#38,#3F,#FC,#7F,#FE,
        #00,#00,#00,#40,#00,#60,#00,#70,#00,#78,#00,#7C,#00,#7E,#00,#7F,
        #80,#7F,#C0,#7F,#E0,#7F,#30,#67,#00,#43,#00,#03,#80,#01,#00,#00}, 
       1, 0}


integer Mouse_Cursor_Store          

Mouse_Cursor_Store = allocate_low(64) 

-- CHANGE_CURSOR() procedure created by Victor Milankovic

global
procedure Change_cursor(integer CursorNo)
  
  sequence reg_list
  
  reg_list=repeat(0,10)
  poke(Mouse_Cursor_Store, Cursors[(CursorNo-1)*3+1])
  reg_list[REG_AX]=#0009
  reg_list[REG_BX]=Cursors[(CursorNo-1)*3+2]
  reg_list[REG_CX]=Cursors[(CursorNo-1)*3+3]
  reg_list[REG_ES]=floor(Mouse_Cursor_Store /16)
  reg_list[REG_DX]=remainder(Mouse_Cursor_Store,16)
  reg_list=dos_interrupt(#33, reg_list)

end procedure


